%main_video_denoisng
%Input:
%   noisy_video --- noisy video file
%   pref_video  --- pre_filtered video for patchmatching
%   sigma       --- std of Gaussian noise
%   cfno        --- the index of frame for denoising
%
%Output:
%   Denoised_frame ---- the de-noised frame of index cfno
%
%
%Note: The routine used the propack package for SVD from 
%soi.stanford.edu/~rmunk/PROPACK and the implementation of partial proximal
%gradient method for robust PCA from http://perception.csl.illinois.edu/matrix-rank/sample_code.html

%Reference: H. Ji, S. Huang, Z. Shen, and Y .-H .Xu, 
%Robust video restoration by joint sparse and low rank matrix approximation, 
%SIAM Journal on Imaging Sciences, 4(4), 1122-1142, Nov. 2011
%
%Author: Huang sibin, Xu Yuhong and Luo Yu
%
%Last Revision: 06-June-2013
%

function denoised_frame = main_video_restoration(noisy_video,pref_video,sigma,cfno)

addpath('./code/apg_partial');
addpath('./code/apg_partial/PROPACK');

%% Get the video infomation
noisy_data = read_video(noisy_video);
pref_data = read_video(pref_video);


%% Patchmatching
display('Patch matching.......');
matchinfo = PatchMatching(pref_data, cfno);

%% Sparse and Low Rank denoising
display('Patch denoising.......');
denoised_frame = PatchDenoiseSL(noisy_data, matchinfo, sigma);


end